<?php

/**
 * This file is part of LEPTON Core, released under the GNU GPL
 * Please see LICENSE and COPYING files in your package for details, specially for terms and warranties.
 * 
 * NOTICE:LEPTON CMS Package has several different licenses.
 * Please see the individual license in the header of each single file or info.php of modules and templates.
 *
 * @author          Website Baker Project, LEPTON Project
 * @copyright       2004-2010, Website Baker Project
 * @copyright       2010-2011, LEPTON Project
 * @link            http://www.LEPTON-cms.org
 * @license         http://www.gnu.org/licenses/gpl.html
 * @license_terms   please see LICENSE and COPYING files in your package
 * @version         $Id: preferences.php 1045 2011-08-27 10:26:19Z frankh $
 *
 */

// include class.secure.php to protect this file and the whole CMS!
if (defined('WB_PATH')) {	
	include(WB_PATH.'/framework/class.secure.php'); 
} elseif (file_exists($_SERVER['DOCUMENT_ROOT'].'/framework/class.secure.php')) {
	include($_SERVER['DOCUMENT_ROOT'].'/framework/class.secure.php'); 
} else {
	$subs = explode('/', dirname($_SERVER['SCRIPT_NAME']));	$dir = $_SERVER['DOCUMENT_ROOT'];
	$inc = false;
	foreach ($subs as $sub) {
		if (empty($sub)) continue; $dir .= '/'.$sub;
		if (file_exists($dir.'/framework/class.secure.php')) { 
			include($dir.'/framework/class.secure.php'); $inc = true;	break; 
		} 
	}
	if (!$inc) trigger_error(sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR);
}
// end include class.secure.php

if(!FRONTEND_LOGIN) {
	if(INTRO_PAGE) {
		die ( header('Location: '.WB_URL.PAGES_DIRECTORY.'/index.php') );
	} else {
		die ( header('Location: '.WB_URL.'/index.php') );
	}
}

include_once(WB_PATH.'/framework/timezones.php');
require_once(WB_PATH.'/framework/class.wb.php');
$wb_inst = new wb();
if ($wb_inst->is_authenticated()==false) die( header('Location: '.WB_URL.'/account/login.php') );

$submit_ok = false;
if (isset($_POST['save']) && ($_POST['save']=='account_settings')) {
	if (isset($_SESSION['wb_apf_hash']) && ($_SESSION['wb_apf_hash'] === $_POST['hash']) ) {
		if ( ( TIME() - $_POST['r_time'] ) <= (60*5) ) {
			/**
			 *	user-password correct?
			 *
			 */
			$user_id = $_SESSION['USER_ID'];
			$query = "SELECT `password` from `".TABLE_PREFIX."users` where `user_id`='".$user_id."' AND `password`='".md5($_POST['current_password'])."'";
			$result = $database->query( $query );
			if ($result->numRows() == 1) {
				$submit_ok = true;
			}
			unset($user_id);
			unset($query);
			unset($result);
			unset($_POST['save']);
		}
	}
}

if (true === $submit_ok) {
	unset($_SESSION['wb_apf_hash']);
	unset($_POST['hash']);
	
	// timezone must match a value in the table
	//global $timezone_table;
	$timezone_string = $wb_inst->get_timezone_string();
	if (in_array($_POST['timezone_string'], $timezone_table)) {
		$timezone_string = $_POST['timezone_string'];
	} 

	$fields = array(
		'display_name'	=> $_POST['display_name'],		# not empty
		'language'		=> $_POST['language'],
		'email'			=> $_POST['email'],				# not empty and valid
		'timezone_string'	=> $timezone_string,
		'time_format'	=> $_POST['time_format'],
		'date_format'	=> $_POST['date_format']
	);
	
	if (isset($_POST['new_password']) && (isset($_POST['new_password2'])) && ($_POST['new_password'] === $_POST['new_password2'])) {
		if ($_POST['new_password'] != "") $fields['password'] = md5($_POST['new_password']);
	}
	
	$q = "UPDATE `".TABLE_PREFIX."users` SET ";
	foreach($fields as $key=>$value) $q .= "`".$key."`='".mysql_real_escape_string($value)."', ";
	$q = substr($q, 0, -2) . " WHERE `user_id`='".$_SESSION['USER_ID']."'";
	
	$database->query( $q );
	if ($database->is_error()) {
		$_SESSION['result_message'] = $database->get_error()."<br /><br />Query was:".$q."<br /><br />";
	} else {
		if (isset($fields['password'])) unset($fields['password']);
		foreach($fields as $k=>$v) $_SESSION[ strtoupper($k) ] = $v;
		
		// Update timezone
		$_SESSION['TIMEZONE_STRING'] = $timezone_string;
		date_default_timezone_set($timezone_string);
		
		/**
		 *	Update time format
		 *
		 */
		if ( $_SESSION['TIME_FORMAT'] != '' ) {
			if(isset($_SESSION['USE_DEFAULT_TIME_FORMAT'])) unset($_SESSION['USE_DEFAULT_TIME_FORMAT']);
		} else {
			$_SESSION['USE_DEFAULT_TIME_FORMAT'] = true;
			unset($_SESSION['TIME_FORMAT']);
		}
		
		/**
		 *	Update date format
		 *
		 */
		if ( $_SESSION['DATE_FORMAT'] != '' ) {
			if(isset($_SESSION['USE_DEFAULT_DATE_FORMAT'])) unset($_SESSION['USE_DEFAULT_DATE_FORMAT']);
		} else {
			$_SESSION['USE_DEFAULT_DATE_FORMAT'] = true;
			unset($_SESSION['DATE_FORMAT']);
		}
	
		$_SESSION['result_message'] = $MESSAGE['PREFERENCES_DETAILS_SAVED']."!<br /><br />";
	}
} else {
	$_SESSION['result_message'] = "";
}

unset($submit_ok);

// Required page details
$page_id = 0;
$page_description = '';
$page_keywords = '';
define('PAGE_ID', 0);
define('ROOT_PARENT', 0);
define('PARENT', 0);
define('LEVEL', 0);
define('PAGE_TITLE', $MENU['PREFERENCES']);
define('MENU_TITLE', $MENU['PREFERENCES']);
define('MODULE', '');
define('VISIBILITY', 'public');

/**
 *	Set the page content include file
 *
 */
define('PAGE_CONTENT', WB_PATH.'/account/preferences_form.php');

/**
 *	Include the index (wrapper) file
 *
 */
require(WB_PATH.'/index.php');

?>